//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  C'225,0,0'
#property indicator_color2  C'0,225,0'
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

extern int    RsiLength1 =  5;
extern int    RsiLength2 =  8;
extern int    RsiLength3 = 11;
extern int    RsiLength4 = 14;
extern int    RsiLength5 = 17;
extern int    RsiLength6 = 20;
extern int    RsiLength7 = 24;
extern int    RsiLength8 =  0;
extern int    RsiPrice   = PRICE_CLOSE;
extern int    Group      = 6;
extern double LevelUp    = 70;
extern double LevelDown  = 30;
extern double GapUp      = 0.25;
extern double GapDown    = 0.25;

double signalUp[];
double signalDn[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,signalUp); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159);
   SetIndexBuffer(1,signalDn); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);
   IndicatorShortName("RSI fan signals");
   return(0);
}
int deinit(){ return(0); }


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);

   for(int i = limit; i>=0; i--)
 	{
      int    result = 0;
      double rsi;
 	    if (RsiLength1>1)  { rsi = iRSI(NULL,0,RsiLength1,RsiPrice,i); result += (rsi > LevelUp); result -= (rsi < LevelDown); }
 	    if (RsiLength2>1)  { rsi = iRSI(NULL,0,RsiLength2,RsiPrice,i); result += (rsi > LevelUp); result -= (rsi < LevelDown); }
 	    if (RsiLength3>1)  { rsi = iRSI(NULL,0,RsiLength3,RsiPrice,i); result += (rsi > LevelUp); result -= (rsi < LevelDown); }
 	    if (RsiLength4>1)  { rsi = iRSI(NULL,0,RsiLength4,RsiPrice,i); result += (rsi > LevelUp); result -= (rsi < LevelDown); }
 	    if (RsiLength5>1)  { rsi = iRSI(NULL,0,RsiLength5,RsiPrice,i); result += (rsi > LevelUp); result -= (rsi < LevelDown); }
 	    if (RsiLength6>1)  { rsi = iRSI(NULL,0,RsiLength6,RsiPrice,i); result += (rsi > LevelUp); result -= (rsi < LevelDown); }
 	    if (RsiLength7>1)  { rsi = iRSI(NULL,0,RsiLength7,RsiPrice,i); result += (rsi > LevelUp); result -= (rsi < LevelDown); }
 	    if (RsiLength8>1)  { rsi = iRSI(NULL,0,RsiLength8,RsiPrice,i); result += (rsi > LevelUp); result -= (rsi < LevelDown); }
 	       signalUp[i] = EMPTY_VALUE;
 	       signalDn[i] = EMPTY_VALUE;
 	          if (result>= Group) signalUp[i] = High[i]+iATR(NULL,0,10,i)*GapUp;
 	          if (result<=-Group) signalDn[i] = Low[i] -iATR(NULL,0,10,i)*GapDown;
   } 	    
   return(0);
}